#ifndef __FATORRGCONVERTER_H__
#define __FATORRGCONVERTER_H__

#include <map>

#include <grammar/Regular/RightRegularGrammar.h>
#include <automaton/FSM/FSM.h>
#include <AlibException.h>

#include "../../interface/IConversionRRG.h"
#include "../../include/macros.h"

namespace conversions
{

/**
 * Finite automata to right regular grammar converter.
 * Source: Melichar 2.104
 */
class FAtoRRGConverter : public IConversionRRG
{
public:
    /**
     * @param automaton Source automata.
     */
    FAtoRRGConverter( const automaton::FSM & automaton );

    ~FAtoRRGConverter( void );

    /**
     * Performs conversion.
     * @return left regular grammar equivalent to source automata.
     */
    grammar::RightRegularGrammar convert ( void );

protected:
    /**
     * input automaton
     */
    const automaton::FSM & m_automaton;
};

} /* namespace conversions */

#endif /* __FATORRGCONVERTER_H__ */
