/*
 * GlushkovRRG.h
 *
 *  Created on: 11. 1. 2014
 *      Author: tomas
 */

#ifndef GLUSHKOVRRG_H_
#define GLUSHKOVRRG_H_

#include <map>

#include <grammar/Regular/RightRegularGrammar.h>
#include <regexp/RegExp.h>

#include "../../interface/IConversionRRG.h"
#include "../../shared/glushkov/GlushkovTraversal.h"

namespace conversions
{

/**
 * Converts regular expression to right regular grammar using Glushkov algorithm.
 * Source: None yet.
 */
class GlushkovRRG : public IConversionRRG
{
public:
    /**
     * @param re Source regular expresison.
     */
    GlushkovRRG( const regexp::RegExp & re );

    ~GlushkovRRG( void );

    /**
     * Performs conversion.
     * @return right regular grammar equivalent to source regexp.
     */
    grammar::RightRegularGrammar convert( void );

private:
    std::map<GlushkovSymbol, alphabet::Symbol> m_symbolMap;
    std::set<GlushkovSymbol> m_first, m_last;
    std::set<GlushkovPair> m_pairs;

    /*
     * input regexp
     */
    const regexp::RegExp & m_re;
};

} /* namespace conversions */

#endif /* GLUSHKOVRRG_H_ */
