/*
 * LRGAlgebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: tomas
 */

#ifndef LRGALGEBRAIC_H_
#define LRGALGEBRAIC_H_

#include <grammar/Regular/LeftRegularGrammar.h>
#include <regexp/RegExp.h>

#include "../../shared/equations/LeftRegularEquationSolver.h"
#include "../../interface/IConversionRE.h"

namespace conversions
{

class LRGAlgebraic: public IConversionRE
{
public:
    /**
     * @param rg Source left regular grammar.
     */
    LRGAlgebraic( const grammar::LeftRegularGrammar & rg );

    ~LRGAlgebraic( void );

    /**
     * @return regexp equivalent to source left regular grammar.
     */
    regexp::RegExp convert( void );

protected:
    /**
     * input grammar
     */
    const grammar::LeftRegularGrammar & m_grammar;
};

} /* namespace conversions */

#endif /* LRGALGEBRAIC_H_ */
