/*
 * LeftToRightRegularGrammar.cpp
 *
 *  Created on: 8. 3. 2014
 *      Author: tomas
 */

#include "LeftToRightRegularGrammar.h"

using namespace alphabet;
using namespace grammar;
using namespace std;

namespace conversions
{

LeftToRightRegularGrammar::LeftToRightRegularGrammar( const grammar::LeftRegularGrammar & lrg ) : m_lrg( lrg )
{

}

LeftToRightRegularGrammar::~LeftToRightRegularGrammar( void )
{

}

RightRegularGrammar LeftToRightRegularGrammar::convert( void )
{
    RightRegularGrammar rrg;

    for( const auto & symbol : m_lrg.getNonTerminalSymbols( ) )
        rrg.addNonTerminalSymbol( symbol );

    for( const auto & symbol : m_lrg.getTerminalSymbols( ) )
        rrg.addTerminalSymbol( symbol );

    // 1.
    Symbol s = rrg.createUniqueNonTerminalSymbol( m_lrg.getStartSymbol( ).getSymbol( ), false );
    rrg.setStartSymbol( s );

    // 2.
    for( const auto & rule : m_lrg.getRules( ) )
    {
        if( rule.getRightSide( ).size( ) == 2 )
        {
            list<Symbol> leftSide = { rule.getRightSide( ).front( ) };
            list<Symbol> rightSide = { rule.getRightSide( ).back( ), rule.getLeftSide( ).front( ) };
            rrg.addRule( Rule( leftSide, rightSide ) );

            if( rule.getLeftSide( ).front( ) == m_lrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { rule.getRightSide( ).front( ) };
                list<Symbol> rightSide = { rule.getRightSide( ).back( ) };
                rrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else if( rule.getRightSide( ).size( ) == 1 )
        {
            list<Symbol> leftSide = { rrg.getStartSymbol( ) };
            list<Symbol> rightSide = { rule.getRightSide( ).front( ), rule.getLeftSide( ).front( ) };
            rrg.addRule( Rule( leftSide, rightSide ) );

            if( rule.getLeftSide( ).front( ) == m_lrg.getStartSymbol( ) )
            {
                list<Symbol> leftSide = { rrg.getStartSymbol( ) };
                list<Symbol> rightSide = { rule.getRightSide( ).front( ) };
                rrg.addRule( Rule( leftSide, rightSide ) );
            }
        }
        else
        {
            // assert leftSide == rrg.getStartSymbol( )
            list<Symbol> leftSide = { rrg.getStartSymbol( ) };
            list<Symbol> rightSide;
            rrg.addRule( Rule( leftSide, rightSide) );
        }
    }

    return rrg;
}

} /* namespace conversions */
